//======================================================================
// Forward declarations for functions that deal directly with the engine
//======================================================================

#define ABSOLUTE_VALUE_EASY(x) (((x) < 0) ? (-(x)) : (x)) //very useful for gpGlobals->time comparisons
#define GetEdictModel(edict) ( (g_engfuncs.pfnInfoKeyValue((*g_engfuncs.pfnGetInfoKeyBuffer)(edict), "model")) )

//just declare extra helper functions you need here

bool UTIL_CanSporify(edict_t *pent);
//void UTIL_TraceLine( const Vector &vecStart, const Vector &vecEnd, IGNORE_MONSTERS igmon, IGNORE_GLASS ignoreGlass, edict_t *pentIgnore, TraceResult *ptr );
CBaseEntity *FindEntityForward( CBaseEntity *pMe );
void UTIL_EndProgress(edict_t *pEntity);
void UTIL_StartProgress(edict_t *pEntity, const int dest, const int mode);
bool UTIL_IsBuilt(edict_t *pent);
void EMIT_SOUND_DYN(edict_t *entity, int channel, const char *sample, float volume, float attenuation, int flags, int pitch);
int UTIL_DoSpore(CBaseEntity *pPlayer,CBaseEntity *pRes, int uiResHeavy, float ufResSTime,float ufResRange, float ufResDmg, float ufResOffset);
int UTIL_GetDistance(CBaseEntity *pEntitya,CBaseEntity *pEntityb);
void UTIL_LogEntityData( edict_t *pEntity, char *UTIL_Logfilename, char *UTIL_Logtag);